//notation: js file can only use this kind of comments
//since comments will cause error when use in webview.loadurl,
//comments will be remove by java use regexp
(function() {
    if (!window.__SNC_LOG__) {
      window.__console = window.console;
      window.__SNC_LOG__ = function() {
        try {
          __console.log.apply(__console, arguments);
          var data = [].slice.call(arguments).map(function(e) {
            var msg = e || '';
            if (typeof e === 'object') {
              try {
                msg = JSON.stringify(e);
              } catch (e) {}
            }
            return msg;
          }).join(' ');
          // @TODO APP 本地上报实现
          window.__console.log('__SNC_LOG__'+data);
          // window.webkit.messageHandlers.__SNC_LOG__.postMessage({
          //   'log_type_hybrid__SNC_LOG__': 'log_type_hybrid__SNC_LOG__',
          //   'message_name': '__SNC_LOG__',
          //   'data': data
          // });
        } catch (e) {}
      };
    };

    if (window.WebViewJavascriptBridge) {
        return;
    }
    var sinaNews_debug = window["sinaNews_debug"] || false;
    var sinaNews_use_quick_chain = window["sinaNews_use_quick_chain"] || false;
    var sinaNews_js_interface = window["sinaNews_js_interface"] || false;
    var sinaNews_console = window.console;

    var __appWidth = window["__appWidth"];
    var messagingIframe;
    var bizMessagingIframe;
    var sendMessageQueue = [];
    var receiveMessageQueue = [];
    var messageHandlers = {};

    var CUSTOM_PROTOCOL_SCHEME = 'sn';
    var QUEUE_HAS_MESSAGE = '__sn__queue_message__';

    var responseCallbacks = {};
    var uniqueId = 1;

    function _createQueueReadyIframe(doc) {
        messagingIframe = doc.createElement('iframe');
        messagingIframe.style.display = 'none';
        doc.documentElement.appendChild(messagingIframe);
    }

    function _createQueueReadyIframe4biz(doc) {
        bizMessagingIframe = doc.createElement('iframe');
        bizMessagingIframe.style.display = 'none';
        doc.documentElement.appendChild(bizMessagingIframe);
    }

    //set default messageHandler  初始化默认的消息线程
    function init(messageHandler) {
        if (WebViewJavascriptBridge._messageHandler) {
            throw new Error('WebViewJavascriptBridge.init called twice');
        }
//        console.log("-------------WebViewJavascriptBridge.init-----------");
        WebViewJavascriptBridge._messageHandler = messageHandler;
        var receivedMessages = receiveMessageQueue;
        receiveMessageQueue = null;
        for (var i = 0; i < receivedMessages.length; i++) {
            _dispatchMessageFromNative(receivedMessages[i]);
        }
    }

    // 发送
    function send(data, responseCallback) {
        _doSend({
            data: data
        }, responseCallback);
    }

    function sendDirect(data, responseCallback) {
        _doSendDirect({
            data: data
        }, responseCallback);
    }

    // 注册线程 往数组里面添加值
    function registerHandler(handlerName, handler) {
        messageHandlers[handlerName] = handler;
    }

    // 调用线程
    function callHandler(handlerName, data, responseCallback) {
        _doSend({
            handlerName: handlerName,
            data: data
        }, responseCallback);
    }

    function callHandlerDirect(handlerName, data, responseCallback) {
        _doSendDirect({
            handlerName: handlerName,
            data: data
        }, responseCallback);
    }

    function _doSendDirect(message, responseCallback) {
        if (sinaNews_use_quick_chain) {
            _doSend(message, responseCallback);
            return;
        }

        if (responseCallback) {
            var callbackId = 'cb_' + (uniqueId++) + '_' + new Date().getTime();
            responseCallbacks[callbackId] = responseCallback;
            message.callbackId = callbackId;
        }
        var messageQueue = [];
        messageQueue.push(message);
        if(sinaNews_debug){
            console.log("发送默认消息体告知Native：");
            console.log("命中快速通道。。。");
        }
        var messageQueueString = JSON.stringify(messageQueue);
        if(sinaNews_js_interface) {
            window._sinaJs2Native.exec(CUSTOM_PROTOCOL_SCHEME + '://send/_fetchQueue/' + encodeURIComponent(messageQueueString))
        } else{
            sinaNews_console.log(CUSTOM_PROTOCOL_SCHEME + '://send/_fetchQueue/' + encodeURIComponent(messageQueueString))
        }
    }

    //sendMessage add message, 触发native处理 sendMessage
    function _doSend(message, responseCallback) {
        if (responseCallback) {
            var callbackId = 'cb_' + (uniqueId++) + '_' + new Date().getTime();
            responseCallbacks[callbackId] = responseCallback;
            message.callbackId = callbackId;
        }
        sendMessageQueue.push(message);

        if(sinaNews_js_interface) {
            window._sinaJs2Native.exec(CUSTOM_PROTOCOL_SCHEME + '://' + QUEUE_HAS_MESSAGE + '/')
        } else{
            sinaNews_console.log(CUSTOM_PROTOCOL_SCHEME + '://' + QUEUE_HAS_MESSAGE + '/');
        }
    }


    // 提供给native调用,该函数作用:获取sendMessageQueue返回给native,由于android不能直接获取返回的内容,所以使用url shouldOverrideUrlLoading 的方式返回内容
    function _fetchQueue(callbackId) {
        var messageQueueString = JSON.stringify(sendMessageQueue);
//        var messageQueueString = sendMessageQueue;
        sendMessageQueue = [];
        if(sinaNews_debug){
            console.log("发送给native消息：");
        }

        if(sinaNews_js_interface) {
            window._sinaJs2Native.exec(CUSTOM_PROTOCOL_SCHEME + '://return/_fetchQueue/' + callbackId + '/' + encodeURIComponent(messageQueueString))
        } else{
            console.log(CUSTOM_PROTOCOL_SCHEME + '://return/_fetchQueue/' + callbackId + '/' + encodeURIComponent(messageQueueString));
        }
    }

    //提供给native使用,
    function _dispatchMessageFromNative(messageJSON) {
        setTimeout(function() {
//            var message = JSON.parse(messageJSON);
            var message = messageJSON;
            var responseCallback;
            //java call finished, now need to call js callback function
            if (message.responseId) {
                responseCallback = responseCallbacks[message.responseId];

                if (!responseCallback) {
                    return;
                }
                responseCallback(message.responseData);
                delete responseCallbacks[message.responseId];
            } else {
                //直接发送
                if (message.callbackId) {
                    var callbackResponseId = message.callbackId;
                    responseCallback = function(responseData) {
                        _doSend({
                            responseId: callbackResponseId,
                            responseData: responseData
                        });
                    };
                }

                var handler = WebViewJavascriptBridge._messageHandler;
                if (message.handlerName) {
                    handler = messageHandlers[message.handlerName];
                }
                //查找指定handler
                try {
                    handler(message.data, responseCallback);
                } catch (exception) {
                    if (typeof console != 'undefined') {
//                        console.log("WebViewJavascriptBridge: WARNING: javascript handler threw.", message, exception);
                    }
                }
            }
        });
    }

    //提供给native调用,receiveMessageQueue 在会在页面加载完后赋值为null,所以
    function _handleMessageFromNative(messageJSON) {
        if(sinaNews_debug){
            console.log("接收到native消息：");
            console.log(messageJSON);
        }
        if (receiveMessageQueue) {
            receiveMessageQueue.push(messageJSON);
        }
        _dispatchMessageFromNative(messageJSON);

    }

    var WebViewJavascriptBridge = window.WebViewJavascriptBridge = {
        init: init,
        send: send,
        sendDirect: sendDirect,
        registerHandler: registerHandler,
        callHandler: callHandler,
        callHandlerDirect: callHandlerDirect,
        _fetchQueue: _fetchQueue,
        _handleMessageFromNative: _handleMessageFromNative
    };

    var doc = document;
    _createQueueReadyIframe(doc);
    _createQueueReadyIframe4biz(doc);
    var readyEvent = doc.createEvent('Events');
    readyEvent.initEvent('WebViewJavascriptBridgeReady');
    readyEvent.bridge = WebViewJavascriptBridge;
    doc.dispatchEvent(readyEvent);
})();
