const highp float maskBlurStep = 1.0/192.0;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform sampler2D inputImageTexture2_mask;
varying highp vec2 vTextureCoord;
uniform int hasBG;

void main(){

    highp float sum = 0.0;

    sum += texture2D(inputImageTexture2_mask, vTextureCoord + vec2(-maskBlurStep, -maskBlurStep)).r * 0.25;
    sum += texture2D(inputImageTexture2_mask, vTextureCoord + vec2(0, -maskBlurStep)).r * 0.01;
    sum += texture2D(inputImageTexture2_mask, vTextureCoord + vec2(maskBlurStep, -maskBlurStep)).r * 0.01;
    sum += texture2D(inputImageTexture2_mask, vTextureCoord + vec2(-maskBlurStep, 0)).r * 0.29;
    sum += texture2D(inputImageTexture2_mask, vTextureCoord).r * 0.18;
    sum += texture2D(inputImageTexture2_mask, vTextureCoord + vec2(maskBlurStep, 0)).r * 0.01;
    sum += texture2D(inputImageTexture2_mask, vTextureCoord + vec2(-maskBlurStep, maskBlurStep)).r * 0.23;
    sum += texture2D(inputImageTexture2_mask, vTextureCoord + vec2(0, maskBlurStep)).r * 0.01;
    sum += texture2D(inputImageTexture2_mask, vTextureCoord + vec2(maskBlurStep, maskBlurStep)).r * 0.01;

    sum = (sum - 0.2) / 0.6;
    sum = clamp(sum, 0.0, 1.0);


    highp vec4 C = texture2D(inputImageTexture,vTextureCoord);
    if (hasBG == 1) {
        highp vec4 BG = texture2D(inputImageTexture2,vTextureCoord);

        gl_FragColor = vec4(mix(BG.xyz, C.xyz, sum), 1.0);
    } else {
        gl_FragColor = vec4(C.xyz, 1.0);
    }

}